FocusEvent.Cause (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt.event, class: FocusEvent, enum: Cause
Keywords: java.awt.event.FocusEvent.Cause class

# Enum Class FocusEvent.Cause

java.lang.Object
java.lang.Enum<FocusEvent.Cause>
java.awt.event.FocusEvent.Cause

All Implemented Interfaces:
  `Serializable, Comparable<FocusEvent.Cause>, Constable`

Enclosing class:
  `FocusEvent`

public static enum FocusEvent.Cause extends Enum<FocusEvent.Cause>
This enum represents the cause of a `FocusEvent`- the reason why it occurred. Possible reasons include mouse events, keyboard focus traversal, window activation. If no cause is provided then the reason is `UNKNOWN`.

Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ACTIVATION`
  An activation of a toplevel window.
  `CLEAR_GLOBAL_FOCUS_OWNER`
  Clearing global focus owner.
  `MOUSE_EVENT`
  An activating mouse event.
  `ROLLBACK`
  Restoring focus after a focus request has been rejected.
  `TRAVERSAL`
  A focus traversal action with unspecified direction.
  `TRAVERSAL_BACKWARD`
  A backward focus traversal action.
  `TRAVERSAL_DOWN`
  A down-cycle focus traversal action.
  `TRAVERSAL_FORWARD`
  A forward focus traversal action.
  `TRAVERSAL_UP`
  An up-cycle focus traversal action.
  `UNEXPECTED`
  A system action causing an unexpected focus change.
  `UNKNOWN`
  The default value.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static FocusEvent.Cause`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static FocusEvent.Cause[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(FocusEvent.Cause o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<FocusEvent.Cause>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<FocusEvent.Cause>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### UNKNOWN

    public static final FocusEvent.Cause UNKNOWN
    The default value.

  - ### MOUSE_EVENT

    public static final FocusEvent.Cause MOUSE_EVENT
    An activating mouse event.

  - ### TRAVERSAL

    public static final FocusEvent.Cause TRAVERSAL
    A focus traversal action with unspecified direction.

  - ### TRAVERSAL_UP

    public static final FocusEvent.Cause TRAVERSAL_UP
    An up-cycle focus traversal action.

  - ### TRAVERSAL_DOWN

    public static final FocusEvent.Cause TRAVERSAL_DOWN
    A down-cycle focus traversal action.

  - ### TRAVERSAL_FORWARD

    public static final FocusEvent.Cause TRAVERSAL_FORWARD
    A forward focus traversal action.

  - ### TRAVERSAL_BACKWARD

    public static final FocusEvent.Cause TRAVERSAL_BACKWARD
    A backward focus traversal action.

  - ### ROLLBACK

    public static final FocusEvent.Cause ROLLBACK
    Restoring focus after a focus request has been rejected.

  - ### UNEXPECTED

    public static final FocusEvent.Cause UNEXPECTED
    A system action causing an unexpected focus change.

  - ### ACTIVATION

    public static final FocusEvent.Cause ACTIVATION
    An activation of a toplevel window.

  - ### CLEAR_GLOBAL_FOCUS_OWNER

    public static final FocusEvent.Cause CLEAR_GLOBAL_FOCUS_OWNER
    Clearing global focus owner.

- ## Method Details

  - ### values

    public static FocusEvent.Cause[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static FocusEvent.Cause valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null